<template>
  <div class="App overflow-y-auto">
    <div class="container mx-auto">
      <div v-if="isReady" class="flex flex-col md:flex-row">
        <PostList :is-rewinding="isRewinding" class="half-width"/>
        <History @revert="rewindAnimation" class="half-width"/>
      </div>
    </div>
  </div>
</template>

<script>
import { mapActions } from 'pinia';
import { useHistoryStore } from '@/stores/HistoryStore';
import { fetchPosts } from '@/services/fetchPosts';
import History from './components/History.vue';
import PostList from './components/PostList.vue';

export default {
  name: 'App',
  components: {
    History,
    PostList,
  },
  methods: {
    ...mapActions(useHistoryStore, ['addPostsOrder']),
    /**
     * @returns {void | Error}
    */
    async fetchPosts() {
      try {
        const posts = await fetchPosts();
        const slicedPosts = posts.slice(0, 5);
        const keyBasedPosts = slicedPosts.map((post) => ({
          postId: post.id,
          uniqueId: this.generateUniqueId(),
        }));
        this.addPostsOrder(keyBasedPosts);
        this.isReady = true;
      } catch (error) {
        throw new Error(error);
      }
    },
    /**
     * @returns {number}
    */
    generateUniqueId() {
      return Math.floor(Date.now() * Math.random());
    },
    /**
     * @returns {void}
    */
    rewindAnimation() {
      this.isRewinding = true;
      setTimeout(() => {
        this.isRewinding = false;
      }, 1000);
    }
  },
  created() {
    this.fetchPosts();
  },
  data() {
    return {
      isReady: false,
      isRewinding: false
    };
  }
}
</script>

<style>
html, body, #app, .App {
  height: 100%;
}
.App {
  background: rgb(98,86,175);
  background: linear-gradient(170deg, rgba(98,86,175,1) 0%, rgba(98,86,175,1) 29.9%, rgba(246,246,246,1) 30%, rgba(246,246,246,1) 100%);
}
.half-width {
  width: 50%;
}

@media screen and (max-width: 768px) {
  .half-width {
    width: 100%;
  }
}
</style>